// ESA (C) 2000-2018 
//
// This file is part of ESA's XMM-Newton Scientific Analysis System (SAS).
//
//    SAS is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    SAS is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with SAS.  If not, see <http://www.gnu.org/licenses/>.
// This  skeleton file was automatically created by
//            pkgmaker 0.1
//            Thursday, December 11 1997
//
// Module: StatisticElement
// Author: Hassan Siddiqui
//
// Description: Stores position and value of data element. Used by Statistic class.
//
// Comments:
//
// Modifications: See ChangeLog
//
// $Id: StatisticElement.cc,v 1.4 2009/09/01 15:50:54 aibarra Exp $

/* SAS-specific */
#include "Tracer.h"

/* Local */
#include "StatisticElement.h"

/* Constructors */
StatisticElement::StatisticElement():
  _position(0),_value(0){PROC; ENDPROC;};

StatisticElement::StatisticElement (const unsigned long position,
				    const double value):
  _position(position), _value(value)
    {PROC; ENDPROC;}

/* Accessors */
/* AI gcc4 porting
  * error: type qualifiers ignored on function return type
  * => remove const
  */
 unsigned long StatisticElement::position() const
{PROC; RETURN _position;}

 double StatisticElement::value() const
{PROC; RETURN _value;}


/* Assignment operator */
StatisticElement& StatisticElement::operator=
(const StatisticElement& element2)
{
  PROC;

  /* Equality check */
  if ( _position == element2.position() && _value == element2.value() )
  {
    ALTRETURNV(*this);
  }

  _position = element2.position();
  _value = element2.value();

  RETURN *this;

}

/* Output stream function */

void StatisticElement::write(ostream& stream) const
{
  PROC;

  stream << "position " << _position << " value " << _value << endl;

  ENDPROC;
}


/* Comparison operators */

bool operator > (const StatisticElement& element1,
		 const StatisticElement& element2)
{
  PROC;

  if (element1.value() > element2.value()) ALTRETURNV(true);

  RETURN false;
}

bool operator < (const StatisticElement& element1,
		 const StatisticElement& element2)
{
  PROC;

  if (element1.value() < element2.value()) ALTRETURNV(true);

  RETURN false;
}



/* I/O Stream functions */
ostream & operator << ( ostream & stream,
			const StatisticElement & element)
{
  PROC;

  element.write(stream);

  RETURN stream;
};
