// ESA (C) 2000-2018 
//
// This file is part of ESA's XMM-Newton Scientific Analysis System (SAS).
//
//    SAS is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    SAS is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with SAS.  If not, see <http://www.gnu.org/licenses/>.
// This  skeleton file was automatically created by
//            pkgmaker 0.1
//            Thursday, December 11 1997
//
// Module: StatisticElement
// Author: Hassan Siddiqui
//
// Description: Stores position and value of data element. Used by Statistic class.
//
// Comments:
//
// Modifications: See ChangeLog
//
// $Id: StatisticElement.h,v 1.5 2009/09/01 15:50:54 aibarra Exp $

#ifndef STATISTICELEMENT_H
#define STATISTICELEMENT_H

/* Utility */
#include "Tracer.h"

//-----------------------------------------------------------------
// class StatisticElement

// Stores position and value of data element. Used by Statistic class.

// NOTE: Through implicit type promotions to double, any numeric input type is accommodated.

//-----------------------------------------------------------------

class StatisticElement
{
public:

  /* Constructors */
  StatisticElement();

  StatisticElement ( const unsigned long position,
		     const double value);

  /* Accessors */
  /* AI gcc4 porting
    * error: type qualifiers ignored on function return type
    * => remove const
    */
  unsigned long position() const;
   double value() const;

    /* Assignment operator */
  StatisticElement& operator=(const StatisticElement& element2);

  /* Output stream method */
  void write(ostream & stream) const;

private:

  unsigned long _position;
  double _value;

};

/* Comparison operators */
bool operator>(const StatisticElement& element1,
	       const StatisticElement& element2);

bool operator<(const StatisticElement& element1,
	       const StatisticElement& element2);


/* I/O Stream functions */
ostream & operator<<(ostream & stream,
		     const StatisticElement& element);

#endif
