// ESA (C) 2000-2018 
//
// This file is part of ESA's XMM-Newton Scientific Analysis System (SAS).
//
//    SAS is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    SAS is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with SAS.  If not, see <http://www.gnu.org/licenses/>.
// This  skeleton file was automatically created by 
//            pkgmaker 0.1
//            Thursday, December 11 1997
// 
// Module: binarytablefilegenerate
// Author: Hassan Siddiqui
//
// Description: task to generate auxiliary files
// 
// Comments: 
//  
// Modifications: See ChangeLog
// 
// $Id: binarytablefilegenerate.cc,v 1.4 2001/12/18 11:26:54 gvacanti Exp $



// General classes

#include <iostream>
#include <string>

// SAS-specific classes

#include "Dal.h"
#include "FileLocator.h"
//#include "DalExt.h"

// General utility functions

#include "Tracer.h"



static const int NUMBER_OF_ROWS = 20;

int main()
{
  PROC;

  string filename = "testbinarytable.fits";

  // Set up output file

  DataSet* set = dataSetServer->open(filename, DataSet::Create);
      

  // Add table

  Table* table = set->addTable("EXAMPLE", NUMBER_OF_ROWS); 

  
  // Add columns

  Column* xcolumnCol = table->addColumn("XCOLUMN", Column::Int16, "Xcolumn Identifier", "XUNITS");
      
  Column* ycolumnCol = table->addColumn("YCOLUMN", Column::Int32, "Ycolumn Identifier", "YUNITS");
      
  Column* zcolumnCol = table->addColumn("ZCOLUMN", Column::Real64, "Zcolumn Identifier", "ZUNITS");
      

  // Populate table


       for (unsigned long i = 0; i < table->rows(); ++i)
	{
	  (xcolumnCol->data()->int16Data())[i]  = i;
	  (ycolumnCol->data()->int32Data())[i]  = i*10;
	  (zcolumnCol->data()->real64Data())[i] = i*100;
	}
 



  // Close dataset

  SAS_DEBUG( cout << " closing  dataset ... " << endl; );
	
  dataSetServer->close(set);

  RETURN 0;
}
